=== debian/changelog ===
reposurgeon (3.45-1) unstable; urgency=medium

  * New upstream release 3.45:
     - Repaired the distribution maker to again include README.adoc, NEWS, TODO.
     - Executable bits are now correctly propagated across SVN branch copies.
     - Tests fall back to (c-)python if pypy is not available.
     - Various minor testsuite and port fixes. Tests now work on Mac OS X.
     - repocutter ported to Go for 40x speedup (more on large repos).
     - repomapper has been ported to Go; repodiffer has been retired.
  * Remove repodiffer which has been retired upstream
  * Bump Standards-Version to 4.2.1 (no change)
  * Change Architecture from "all" back to "any"
    because some tools have been rewritten in Go.
  * Add "Build-Depends: golang-any" for building repocutter and repomapper
    which have been rewritten in Go.
  * Build with '-{gc,asm}flags all=-trimpath=' for reproducibility.
    Copied from dh-golang (1.38).
    See also https://github.com/restic/restic/issues/2061
    and https://gitlab.com/esr/reposurgeon/merge_requests/181

 -- Anthony Fok <foka@debian.org>  Fri, 21 Dec 2018 17:23:02 -0700
