=== debian/control ===
Source: reposurgeon
Maintainer: Anthony Fok <foka@debian.org>
Section: vcs
Priority: optional
Build-Depends: debhelper (>= 11),
               dh-python,
               golang-any,
               pypy,
               python,
               pkg-config,
               pylint,
               time,
               tzdata,
               xmlto,
               asciidoc-base,
               cvs,
               git,
               mercurial,
               subversion
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
Homepage: http://www.catb.org/esr/reposurgeon/

Package: reposurgeon
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${pypy:Depends},
         tzdata
Recommends: git,
            cvs-fast-export
Suggests: bzr-fastimport,
          hg-fast-export,
          subversion,
          darcs,
          fossil
Description: Tool for editing version-control repository history
 `reposurgeon` enables risky operations that version-control systems
 don't want to let you do, such as (a) editing past comments and metadata,
 (b) excising commits, (c) coalescing commits, and (d) removing files and
 subtrees from repo history. The original motivation for `reposurgeon`
 was to clean up artifacts created by repository conversions.
 .
 `reposurgeon` is also useful for scripting very high-quality
 conversions from Subversion.  It is better than `git-svn` at tag
 lifting, automatically cleaning up `cvs2svn` conversion artifacts,
 dealing with nonstandard repository layouts, recognizing branch
 merges, handling mixed-branch commits, and generally at coping with
 Subversion's many odd corner cases.  Normally Subversion repos should
 be analyzed at a rate of upwards of ten thousand commits per minute,
 though that rate can fall significantly on extremely large
 repositories.
 .
 Another auxiliary program, `repotool`, performs various useful
 operations such as checkouts and tag listing in a VCS-independent
 manner.  Yet another, `repomapper`, assists in automatically preparing
 contributor maps of CVS and SVN repositories.
 .
 The `repocutter` program is available for some specialized operations on
 Subversion dumpfiles; it may be useful in extracting portions of
 particularly gnarly Subversion repositories for conversion witth
 reposurgeon.
 .
 This distribution supports a generic conversion workflow using these
 tools, and includes the DVCS Migration Guide that describes how to use it.
