=== debian/rules ===
#!/usr/bin/make -f

export PYLINTHOME := $(CURDIR)/.pylint.d

%:
	dh $@ --with pypy

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
