=== debian/changelog ===
reposurgeon (4.3+git20200214.8d048e1-1ubuntu0.2) focal-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Fri, 20 Jan 2023 17:37:29 +0100

reposurgeon (4.3+git20200214.8d048e1-1ubuntu0.1) focal-security; urgency=medium

  * No-change rebuild due to golang-1.13 update

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 11 Oct 2022 02:38:51 +0200

reposurgeon (4.3+git20200214.8d048e1-1) unstable; urgency=medium

  * New upstream version 4.3+git20200214.8d048e1
  * debian/control: Build on 64-bit architectures only, at least for now.
    See https://gitlab.com/esr/reposurgeon/issues/255#note_288045356
  * Remove 0001-asciidoctor-disable-webfonts.patch
    which has been applied upstream, see
    https://gitlab.com/esr/reposurgeon/-/merge_requests/456 and
    https://gitlab.com/esr/reposurgeon/-/commit/8d048e1

 -- Anthony Fok <foka@debian.org>  Fri, 14 Feb 2020 15:23:45 -0700

reposurgeon (4.2-1) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Recommend brz rather than bzr-fastimport.

  [ Anthony Fok ]
  * New upstream version 4.2
  * Apply "cme fix dpkg" fixes
    - Update debhelper dependency to "Build-Depends: debhelper-compat (= 12)"
    - Bump Standards-Version to 4.5.0 (no change)
  * Update debian/copyright with correct BSD-2-Clause text
    and with new author and copyright years
  * Remove 0001-build-with-trimpath-for-reproducibility.patch
  * Adapt Debian packaging to the new Go reposurgeon
  * Include yet-to-be-packaged dependent Go libraries
  * Disable webfonts in Asciidoctor-generated HTML files
    (Lintian warning "reposurgeon: privacy-breach-generic")

 -- Anthony Fok <foka@debian.org>  Thu, 13 Feb 2020 13:28:18 -0700
