=== debian/control ===
--- 
+++ 
@@ -1,40 +1,46 @@
 Source: reposurgeon
-Maintainer: Anthony Fok <foka@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
+Testsuite: autopkgtest-pkg-go
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: asciidoctor,
+               cvs,
+               debhelper-compat (= 12),
+               dh-golang,
                dh-python,
+               git,
                golang-any,
-               pypy,
-               python,
-               pkg-config,
-               pylint,
+               golang-github-anmitsu-go-shlex-dev,
+               golang-github-emirpasic-gods-dev,
+               golang-golang-x-crypto-dev,
+               golang-golang-x-text-dev,
+               golint,
+               mercurial,
+               python3,
+               subversion,
                time,
-               tzdata,
-               xmlto,
-               asciidoc-base,
-               cvs,
-               git,
-               mercurial,
-               subversion
-Standards-Version: 4.2.1
+               tzdata
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
 Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
+XS-Go-Import-Path: gitlab.com/esr/reposurgeon
 
 Package: reposurgeon
-Architecture: any
-Depends: ${shlibs:Depends},
+Architecture: amd64 arm64 mips64el ppc64el s390x alpha ia64 kfreebsd-amd64 ppc64 riscv64 sparc64
+Depends: tzdata,
          ${misc:Depends},
-         ${pypy:Depends},
-         tzdata
-Recommends: git,
-            cvs-fast-export
-Suggests: bzr-fastimport,
+         ${python3:Depends},
+         ${shlibs:Depends}
+Recommends: cvs-fast-export,
+            git
+Suggests: brz,
+          darcs,
+          fossil,
           hg-fast-export,
-          subversion,
-          darcs,
-          fossil
+          subversion
+Built-Using: ${misc:Built-Using}
 Description: Tool for editing version-control repository history
  `reposurgeon` enables risky operations that version-control systems
  don't want to let you do, such as (a) editing past comments and metadata,
