=== debian/watch ===
# HTTP site (basic)
#version=4
#http://www.catb.org/~esr/reposurgeon/ \
#    reposurgeon-(\d[\d.]*)\.tar\.(?:gz|bz2|xz) debian

# direct access to the git repository (tags)
#version=4
#opts="mode=git, gitmode=full, pgpmode=none" \
#    https://gitlab.com/esr/reposurgeon.git \
#    refs/tags/([\d\.]+) debian

# direct access to the git repository (HEAD)
version=4
opts="mode=git, pgpmode=none, pretty=4.3+git%cd.%h" \
    https://gitlab.com/esr/reposurgeon.git \
    HEAD debian
