## reposurgeon 4.4

=== Makefile ===
--- 
+++ 
@@ -21,7 +21,7 @@
         surgeon/reposurgeon_test.go \
         surgeon/selection.go \
 	repomapper.adoc repocutter.adoc \
-	reporting-bugs.adoc features.adoc dvcs-migration-guide.adoc \
+	reporting-bugs.adoc dvcs-migration-guide.adoc \
 	reposurgeon-mode.el \
         go.mod
 SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
@@ -37,7 +37,7 @@
 BINARIES = reposurgeon repotool repomapper repocutter
 MANPAGES = reposurgeon.1 repotool.1 repomapper.1 repocutter.1
 HTMLFILES = $(MANPAGES:.1=.html) \
-            dvcs-migration-guide.html features.html reporting-bugs.html
+            repository-editing.html dvcs-migration-guide.html reporting-bugs.html
 SHARED    = $(DOCS) reposurgeon-git-aliases $(HTMLFILES)
 
 # The following would produce reproducible builds, but it breaks Gitlab CI.
@@ -114,7 +114,7 @@
 #
 
 check: lint build test
-	cd test; $(MAKE) --quiet fullcheck
+	cd test; $(MAKE) --quiet check
 
 #
 # Continuous integration.  More specifics are in the ci/ directory
@@ -152,7 +152,7 @@
 reposurgeon-$(VERS).md5: reposurgeon-$(VERS).tar.xz
 	@md5sum reposurgeon-$(VERS).tar.xz >reposurgeon-$(VERS).md5
 
-release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html dvcs-migration-guide.html features.html
+release: reposurgeon-$(VERS).tar.xz reposurgeon-$(VERS).md5 reposurgeon.html repocutter.html repomapper.html reporting-bugs.html repository-editing.html dvcs-migration-guide.html
 	shipper version=$(VERS) | sh -e -x
 
 refresh: reposurgeon.html repocutter.html repomapper.html reporting-bugs.html features.html
