=== test/Makefile ===
--- 
+++ 
@@ -46,12 +46,8 @@
 # Exploit make parallelism
 PARALLEL_MAKE=make --output-sync --no-print-directory -j $(CONCURRENT_JOBS)
 
-# This series can change depending on the current development focus
-fastcheck: clean disclose $(BASIC) $(SUBVERSION)
-	@echo "=== No diff output is good news ==="
-
 # This should always be a full test
-fullcheck: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS)
+check: clean disclose $(BASIC) $(FULLSUBVERSION) $(GIT_EXTRACTOR) $(HG_EXTRACTOR) $(AUXTOOLS)
 	@echo "=== No diff output is good news ==="
 
 disclose:
@@ -312,3 +308,8 @@
 	@REPOSURGEON=$(REPOSURGEON); export REPOSURGEON; TESTOPT="$(TESTOPT)"; export TESTOPT; BUILDOPT="$(BUILDOPT)"; export BUILDOPT;\
 	for file in $(HGPATHO); do \
 	    echo "Remaking $${file}.fi"; \
+	    ./hg-$${file}-test 2>/dev/null | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
+		2>&1 || exit $(STOPOUT); \
+	done
+hg-regress-patho:
+	@echo "=== Testing hg-extractor with pathological loads:"
