=== debian/changelog ===
reposurgeon (4.4-1) unstable; urgency=medium

  * New upstream version 4.4
  * Set debian/watch to track release tarball as before
  * Add "Rules-Requires-Root: no" to debian/control
  * Add 0001-restore-missing-files.patch to restore surgeon/svnread.go,
    repository-editing.adoc and lintfilter which are missing in the
    reposurgeon-4.4.tar.xz upstream tarball
  * Build repository-editing.html instead of features.html
    which has been merged into the former and removed.

 -- Anthony Fok <foka@debian.org>  Wed, 04 Mar 2020 05:34:35 -0700
