=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: reposurgeon
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
+Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
 Testsuite: autopkgtest-pkg-go
 Priority: optional
@@ -25,6 +24,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
 Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
+Rules-Requires-Root: no
 XS-Go-Import-Path: gitlab.com/esr/reposurgeon
 
 Package: reposurgeon
